From d72f0970129daa4627ae1ab65a31faa188b45342 Mon Sep 17 00:00:00 2001
From: opyale <opyale@noreply.codeberg.org>
Date: Tue, 13 Apr 2021 20:56:50 +0200
Subject: [PATCH] Implement multi-session notification polling and additional
 improvements/refactors/cleanups/fixes (#875)

Merge branch 'master' of https://codeberg.org/gitnex/GitNex into notifications-performance-improvements

 Conflicts:
	app/src/main/java/org/mian/gitnex/adapters/DraftsAdapter.java
	app/src/main/java/org/mian/gitnex/adapters/NotificationsAdapter.java
	app/src/main/java/org/mian/gitnex/adapters/UserAccountsAdapter.java
	app/src/main/java/org/mian/gitnex/adapters/UserAccountsNavAdapter.java
	app/src/main/res/layout/bottom_sheet_repository_in_list.xml
	app/src/main/res/layout/list_files.xml

Merge branch 'master' into notifications-performance-improvements

Merge branch 'master' into notifications-performance-improvements

Merge branch 'master' of https://codeberg.org/gitnex/GitNex into notifications-performance-improvements

 Conflicts:
	app/src/main/res/values-it/strings.xml

Add ripple effect to buttons.

Run syntax highlighting on separate thread. (#859)

Initial commit.

Reviewed-on: https://codeberg.org/gitnex/GitNex/pulls/875
Reviewed-by: M M Arif <mmarif@noreply.codeberg.org>
Co-Authored-By: opyale <opyale@noreply.codeberg.org>
Co-Committed-By: opyale <opyale@noreply.codeberg.org>
---
 .../activities/AddNewAccountActivity.java     |  12 +-
 .../gitnex/activities/DeepLinksActivity.java  |  18 ++-
 .../mian/gitnex/activities/LoginActivity.java |  21 ++--
 .../mian/gitnex/activities/MainActivity.java  |  97 +++++---------
 .../RepositorySettingsActivity.java           |   7 +-
 .../SettingsNotificationsActivity.java        |   8 +-
 .../mian/gitnex/adapters/DraftsAdapter.java   |   5 +-
 .../adapters/ExploreRepositoriesAdapter.java  |   3 +-
 .../gitnex/adapters/MyReposListAdapter.java   |   3 +-
 .../gitnex/adapters/NotificationsAdapter.java |  11 +-
 .../gitnex/adapters/RepoForksAdapter.java     |   3 +-
 .../gitnex/adapters/ReposListAdapter.java     |   3 +-
 .../adapters/RepositoriesByOrgAdapter.java    |   3 +-
 .../gitnex/adapters/SearchIssuesAdapter.java  |   3 +-
 .../adapters/StarredReposListAdapter.java     |   3 +-
 .../gitnex/adapters/UserAccountsAdapter.java  |  17 +--
 .../adapters/UserAccountsNavAdapter.java      |  18 +--
 .../org/mian/gitnex/core/MainApplication.java |  32 +++--
 .../org/mian/gitnex/database/api/BaseApi.java |  57 +++++++++
 .../mian/gitnex/database/api/DraftsApi.java   |  82 +++---------
 .../gitnex/database/api/RepositoriesApi.java  | 105 +++-------------
 .../gitnex/database/api/UserAccountsApi.java  | 107 ++++------------
 .../gitnex/database/dao/UserAccountsDao.java  |  19 +--
 .../gitnex/database/db/GitnexDatabase.java    |  39 +++---
 .../fragments/BottomSheetReplyFragment.java   |   5 +-
 .../mian/gitnex/fragments/DraftsFragment.java |   5 +-
 .../fragments/RepositoriesFragment.java       |   3 +-
 .../fragments/UserAccountsFragment.java       |   3 +-
 .../java/org/mian/gitnex/helpers/AppUtil.java |  38 ++++--
 .../mian/gitnex/helpers/Authorization.java    |   6 +-
 .../org/mian/gitnex/helpers/Constants.java    |   5 +
 .../java/org/mian/gitnex/helpers/Version.java |   2 +-
 .../helpers/highlightjs/HighlightJsView.java  |   0
 .../helpers/views/SyntaxHighlightedArea.java  |  74 +++++++----
 .../gitnex/notifications/Notifications.java   |  58 +++------
 .../notifications/NotificationsWorker.java    | 118 +++++++++++-------
 ...ctivity_add_collaborator_to_repository.xml |   3 +
 .../layout/activity_add_new_team_member.xml   |   3 +
 .../res/layout/activity_admin_cron_tasks.xml  |   3 +
 .../res/layout/activity_admin_get_users.xml   |   3 +
 app/src/main/res/layout/activity_commits.xml  |   3 +
 .../main/res/layout/activity_create_file.xml  |   3 +
 .../main/res/layout/activity_create_issue.xml |   3 +
 .../main/res/layout/activity_create_label.xml |   3 +
 .../res/layout/activity_create_milestone.xml  |   3 +
 .../res/layout/activity_create_new_user.xml   |   3 +
 .../layout/activity_create_organization.xml   |   3 +
 .../main/res/layout/activity_create_pr.xml    |   3 +
 .../res/layout/activity_create_release.xml    |   3 +
 .../main/res/layout/activity_create_repo.xml  |   3 +
 .../layout/activity_create_team_by_org.xml    |   3 +
 .../main/res/layout/activity_edit_issue.xml   |   3 +
 .../main/res/layout/activity_file_diff.xml    |   3 +
 .../main/res/layout/activity_file_view.xml    |   3 +
 .../layout/activity_merge_pull_request.xml    |   3 +
 .../res/layout/activity_org_team_members.xml  |   3 +
 .../res/layout/activity_profile_email.xml     |   3 +
 .../main/res/layout/activity_repo_forks.xml   |   3 +
 .../res/layout/activity_repo_stargazers.xml   |   3 +
 .../res/layout/activity_repo_watchers.xml     |   3 +
 .../layout/activity_repository_settings.xml   |  59 +++++----
 .../layout/activity_settings_appearance.xml   |  80 +++++++-----
 .../res/layout/activity_settings_drafts.xml   |  41 +++---
 .../res/layout/activity_settings_general.xml  |  58 +++++----
 .../activity_settings_notifications.xml       | 101 ++++++++-------
 .../res/layout/activity_settings_reports.xml  |  36 +++---
 .../res/layout/activity_settings_security.xml | 101 ++++++++-------
 .../layout/activity_settings_translation.xml  |  33 +++--
 .../res/layout/bottom_sheet_admin_users.xml   |  11 +-
 .../main/res/layout/bottom_sheet_drafts.xml   |  11 +-
 .../res/layout/bottom_sheet_file_viewer.xml   |  17 ++-
 .../layout/bottom_sheet_issue_comments.xml    |  42 +++++--
 .../res/layout/bottom_sheet_issues_filter.xml |  14 ++-
 .../layout/bottom_sheet_labels_in_list.xml    |  16 ++-
 .../layout/bottom_sheet_milestones_filter.xml |  14 ++-
 .../bottom_sheet_milestones_in_list.xml       |  14 ++-
 .../res/layout/bottom_sheet_notifications.xml |  21 +++-
 .../bottom_sheet_notifications_filter.xml     |  14 ++-
 .../res/layout/bottom_sheet_organization.xml  |  28 +++--
 .../bottom_sheet_organization_teams.xml       |   7 +-
 .../main/res/layout/bottom_sheet_profile.xml  |   7 +-
 .../bottom_sheet_pull_request_filter.xml      |  14 ++-
 .../res/layout/bottom_sheet_reply_layout.xml  |   8 +-
 app/src/main/res/layout/bottom_sheet_repo.xml |  85 ++++++++++---
 .../res/layout/bottom_sheet_single_issue.xml  |  81 ++++++++----
 app/src/main/res/layout/fragment_profile.xml  |  11 +-
 .../main/res/layout/fragment_repo_info.xml    |  12 ++
 app/src/main/res/layout/fragment_settings.xml |  76 ++++++++---
 app/src/main/res/values-ar/strings.xml        |   2 +-
 app/src/main/res/values-cs/strings.xml        |   2 +-
 app/src/main/res/values-de/strings.xml        |   2 +-
 app/src/main/res/values-es/strings.xml        |   2 +-
 app/src/main/res/values-fa/strings.xml        |   2 +-
 app/src/main/res/values-fi/strings.xml        |   2 +-
 app/src/main/res/values-fr/strings.xml        |   2 +-
 app/src/main/res/values-it/strings.xml        |   6 +-
 app/src/main/res/values-lv/strings.xml        |   2 +-
 app/src/main/res/values-pl/strings.xml        |   2 +-
 app/src/main/res/values-pt/strings.xml        |   2 +-
 app/src/main/res/values-ru/strings.xml        |   2 +-
 app/src/main/res/values-sr/strings.xml        |   2 +-
 app/src/main/res/values-tr/strings.xml        |   2 +-
 app/src/main/res/values-uk/strings.xml        |   2 +-
 app/src/main/res/values-zh/strings.xml        |   2 +-
 app/src/main/res/values/colors.xml            |   1 +
 app/src/main/res/values/strings.xml           |   2 +-
 app/src/main/res/values/themes.xml            |   2 +-
 gradle.properties                             |   1 +
 108 files changed, 1211 insertions(+), 908 deletions(-)
 create mode 100644 app/src/main/java/org/mian/gitnex/database/api/BaseApi.java
 delete mode 100644 app/src/main/java/org/mian/gitnex/helpers/highlightjs/HighlightJsView.java

diff --git a/app/src/main/java/org/mian/gitnex/activities/AddNewAccountActivity.java b/app/src/main/java/org/mian/gitnex/activities/AddNewAccountActivity.java
index 016e1002..8724df32 100644
--- a/app/src/main/java/org/mian/gitnex/activities/AddNewAccountActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/AddNewAccountActivity.java
@@ -12,6 +12,7 @@ import org.gitnex.tea4j.models.GiteaVersion;
 import org.gitnex.tea4j.models.UserInfo;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.databinding.ActivityAddNewAccountBinding;
 import org.mian.gitnex.helpers.AppUtil;
@@ -114,9 +115,7 @@ public class AddNewAccountActivity extends BaseActivity {
 	private void versionCheck(final String instanceUrl, final String loginToken) {
 
 		Call<GiteaVersion> callVersion;
-
 		callVersion = RetrofitClient.getApiInterface(ctx).getGiteaVersionWithToken("token " + loginToken);
-
 		callVersion.enqueue(new Callback<GiteaVersion>() {
 
 			@Override
@@ -205,14 +204,15 @@ public class AddNewAccountActivity extends BaseActivity {
 						assert userDetails != null;
 						// insert new account to db if does not exist
 						String accountName = userDetails.getUsername() + "@" + instanceUrl;
-						UserAccountsApi userAccountsApi = new UserAccountsApi(ctx);
-						int checkAccount = userAccountsApi.getCount(accountName);
+						UserAccountsApi userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
+						boolean userAccountExists = userAccountsApi.userAccountExists(accountName);
 
-						if(checkAccount == 0) {
+						if(!userAccountExists) {
 
-							userAccountsApi.insertNewAccount(accountName, instanceUrl, userDetails.getUsername(), loginToken, "");
+							userAccountsApi.createNewAccount(accountName, instanceUrl, userDetails.getUsername(), loginToken, "");
 							Toasty.success(ctx, getResources().getString(R.string.accountAddedMessage));
 							finish();
+
 						}
 						else {
 
diff --git a/app/src/main/java/org/mian/gitnex/activities/DeepLinksActivity.java b/app/src/main/java/org/mian/gitnex/activities/DeepLinksActivity.java
index 42be2a54..8e0a85bd 100644
--- a/app/src/main/java/org/mian/gitnex/activities/DeepLinksActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/DeepLinksActivity.java
@@ -13,11 +13,13 @@ import org.gitnex.tea4j.models.PullRequests;
 import org.gitnex.tea4j.models.UserRepositories;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.Repository;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.databinding.ActivityDeeplinksBinding;
+import org.mian.gitnex.helpers.AppUtil;
 import org.mian.gitnex.helpers.UrlHelper;
 import java.net.URI;
 import java.util.List;
@@ -65,7 +67,7 @@ public class DeepLinksActivity extends BaseActivity {
 		}
 
 		// check for the links(URI) to be in the db
-		UserAccountsApi userAccountsApi = new UserAccountsApi(ctx);
+		UserAccountsApi userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
 		List<UserAccount> userAccounts = userAccountsApi.usersAccounts();
 
 		for(UserAccount userAccount : userAccounts) {
@@ -79,13 +81,9 @@ public class DeepLinksActivity extends BaseActivity {
 
 				accountFound = true;
 
-				tinyDB.putString("loginUid", userAccount.getUserName());
-				tinyDB.putString("userLogin", userAccount.getUserName());
-				tinyDB.putString(userAccount.getUserName() + "-token", userAccount.getToken());
-				tinyDB.putString("instanceUrl", userAccount.getInstanceUrl());
-				tinyDB.putInt("currentActiveAccountId", userAccount.getAccountId());
-
+				AppUtil.switchToAccount(ctx, userAccount);
 				break;
+
 			}
 		}
 
@@ -112,7 +110,7 @@ public class DeepLinksActivity extends BaseActivity {
 						final String repoName = restOfUrl[restOfUrl.length - 3];
 
 						int currentActiveAccountId = tinyDB.getInt("currentActiveAccountId");
-						RepositoriesApi repositoryData = new RepositoriesApi(ctx);
+						RepositoriesApi repositoryData = BaseApi.getInstance(ctx, RepositoriesApi.class);
 
 						Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
 
@@ -344,7 +342,7 @@ public class DeepLinksActivity extends BaseActivity {
 					tinyDB.putString("repoFullName", repoOwner + "/" + repoName);
 
 					int currentActiveAccountId = tinyDB.getInt("currentActiveAccountId");
-					RepositoriesApi repositoryData = new RepositoriesApi(ctx);
+					RepositoriesApi repositoryData = BaseApi.getInstance(ctx, RepositoriesApi.class);
 
 					Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
 
@@ -415,7 +413,7 @@ public class DeepLinksActivity extends BaseActivity {
 					tinyDB.putString("repoBranch", repoInfo.getDefault_branch());
 
 					int currentActiveAccountId = tinyDB.getInt("currentActiveAccountId");
-					RepositoriesApi repositoryData = new RepositoriesApi(ctx);
+					RepositoriesApi repositoryData = BaseApi.getInstance(ctx, RepositoriesApi.class);
 
 					Integer count = repositoryData.checkRepository(currentActiveAccountId, repoOwner, repoName);
 
diff --git a/app/src/main/java/org/mian/gitnex/activities/LoginActivity.java b/app/src/main/java/org/mian/gitnex/activities/LoginActivity.java
index 4c3698cd..2f86521b 100644
--- a/app/src/main/java/org/mian/gitnex/activities/LoginActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/LoginActivity.java
@@ -17,6 +17,7 @@ import org.gitnex.tea4j.models.UserInfo;
 import org.gitnex.tea4j.models.UserTokens;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.databinding.ActivityLoginBinding;
@@ -358,19 +359,19 @@ public class LoginActivity extends BaseActivity {
 
 						// insert new account to db if does not exist
 						String accountName = userDetails.getUsername() + "@" + TinyDB.getInstance(ctx).getString("instanceUrl");
-						UserAccountsApi userAccountsApi = new UserAccountsApi(ctx);
-						int checkAccount = userAccountsApi.getCount(accountName);
+						UserAccountsApi userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
+						boolean userAccountExists = userAccountsApi.userAccountExists(accountName);
 						long accountId;
 
-						if(checkAccount == 0) {
+						if(!userAccountExists) {
 
-							accountId = userAccountsApi.insertNewAccount(accountName, TinyDB.getInstance(ctx).getString("instanceUrl"), userDetails.getUsername(), loginToken, "");
+							accountId = userAccountsApi.createNewAccount(accountName, TinyDB.getInstance(ctx).getString("instanceUrl"), userDetails.getUsername(), loginToken, "");
 							tinyDB.putInt("currentActiveAccountId", (int) accountId);
 						}
 						else {
 
 							userAccountsApi.updateTokenByAccountName(accountName, loginToken);
-							UserAccount data = userAccountsApi.getAccountData(accountName);
+							UserAccount data = userAccountsApi.getAccountByName(accountName);
 							tinyDB.putInt("currentActiveAccountId", data.getAccountId());
 						}
 
@@ -546,20 +547,20 @@ public class LoginActivity extends BaseActivity {
 
 										// insert new account to db if does not exist
 										String accountName = userDetails.getUsername() + "@" + TinyDB.getInstance(ctx).getString("instanceUrl");
-										UserAccountsApi userAccountsApi = new UserAccountsApi(ctx);
-										int checkAccount = userAccountsApi.getCount(accountName);
+										UserAccountsApi userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
+										boolean userAccountExists = userAccountsApi.userAccountExists(accountName);
 										long accountId;
 
-										if(checkAccount == 0) {
+										if(!userAccountExists) {
 
 											accountId = userAccountsApi
-												.insertNewAccount(accountName, TinyDB.getInstance(ctx).getString("instanceUrl"), userDetails.getUsername(), newToken.getSha1(), "");
+												.createNewAccount(accountName, TinyDB.getInstance(ctx).getString("instanceUrl"), userDetails.getUsername(), newToken.getSha1(), "");
 											tinyDB.putInt("currentActiveAccountId", (int) accountId);
 										}
 										else {
 
 											userAccountsApi.updateTokenByAccountName(accountName, newToken.getSha1());
-											UserAccount data = userAccountsApi.getAccountData(accountName);
+											UserAccount data = userAccountsApi.getAccountByName(accountName);
 											tinyDB.putInt("currentActiveAccountId", data.getAccountId());
 										}
 
diff --git a/app/src/main/java/org/mian/gitnex/activities/MainActivity.java b/app/src/main/java/org/mian/gitnex/activities/MainActivity.java
index 29e8565f..37dc223a 100644
--- a/app/src/main/java/org/mian/gitnex/activities/MainActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/MainActivity.java
@@ -20,7 +20,6 @@ import androidx.appcompat.widget.Toolbar;
 import androidx.biometric.BiometricPrompt;
 import androidx.cardview.widget.CardView;
 import androidx.core.content.ContextCompat;
-import androidx.core.content.res.ResourcesCompat;
 import androidx.core.view.GravityCompat;
 import androidx.drawerlayout.widget.DrawerLayout;
 import androidx.fragment.app.Fragment;
@@ -34,6 +33,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.adapters.UserAccountsNavAdapter;
 import org.mian.gitnex.clients.PicassoService;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.databinding.ActivityMainBinding;
@@ -90,38 +90,25 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 		ActivityMainBinding activityMainBinding = ActivityMainBinding.inflate(getLayoutInflater());
 		setContentView(activityMainBinding.getRoot());
 
-		tinyDB.putBoolean("noConnection", false);
-
-		String currentVersion = tinyDB.getString("giteaVersion");
-
 		Intent mainIntent = getIntent();
-		String launchFragment = mainIntent.getStringExtra("launchFragment");
+
+		// DO NOT MOVE
+		if(mainIntent.hasExtra("switchAccountId") &&
+			AppUtil.switchToAccount(ctx, BaseApi.getInstance(ctx, UserAccountsApi.class)
+				.getAccountById(mainIntent.getIntExtra("switchAccountId", 0)))) {
+
+			mainIntent.removeExtra("switchAccountId");
+			recreate();
+			return;
+
+		}
+		// DO NOT MOVE
+
+		tinyDB.putBoolean("noConnection", false);
 
 		loginUid = tinyDB.getString("loginUid");
 		instanceToken = "token " + tinyDB.getString(loginUid + "-token");
 
-		if(tinyDB.getString("dateFormat").isEmpty()) {
-
-			tinyDB.putString("dateFormat", "pretty");
-		}
-
-		if(tinyDB.getString("codeBlockStr").isEmpty()) {
-
-			tinyDB.putInt("codeBlockColor", ResourcesCompat.getColor(getResources(), R.color.colorLightGreen, null));
-			tinyDB.putInt("codeBlockBackground", ResourcesCompat.getColor(getResources(), R.color.black, null));
-		}
-
-		if(tinyDB.getString("enableCounterIssueBadgeInit").isEmpty()) {
-
-			tinyDB.putBoolean("enableCounterIssueBadge", true);
-		}
-
-		if(tinyDB.getString("homeScreenStr").isEmpty()) {
-
-			tinyDB.putString("homeScreenStr", "yes");
-			tinyDB.putInt("homeScreenId", 0);
-		}
-
 		boolean connToInternet = AppUtil.hasNetworkConnection(appCtx);
 
 		if(!tinyDB.getBoolean("loggedInMode")) {
@@ -130,9 +117,10 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 			return;
 		}
 
-		if(tinyDB.getInt("currentActiveAccountId") <= 0) {
-
-			AlertDialogs.forceLogoutDialog(ctx, getResources().getString(R.string.forceLogoutDialogHeader), getResources().getString(R.string.forceLogoutDialogDescription), getResources().getString(R.string.alertDialogTokenRevokedCopyPositiveButton));
+		if(tinyDB.getInt("currentActiveAccountId", -1) <= 0) {
+			AlertDialogs.forceLogoutDialog(ctx,
+				getResources().getString(R.string.forceLogoutDialogHeader),
+				getResources().getString(R.string.forceLogoutDialogDescription), getResources().getString(R.string.alertDialogTokenRevokedCopyPositiveButton));
 		}
 
 		Toolbar toolbar = activityMainBinding.toolbar;
@@ -141,17 +129,17 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 		switch(tinyDB.getInt("customFontId", -1)) {
 
 			case 0:
-
 				myTypeface = Typeface.createFromAsset(getAssets(), "fonts/roboto.ttf");
 				break;
-			case 2:
 
+			case 2:
 				myTypeface = Typeface.createFromAsset(getAssets(), "fonts/sourcecodeproregular.ttf");
 				break;
-			default:
 
+			default:
 				myTypeface = Typeface.createFromAsset(getAssets(), "fonts/manroperegular.ttf");
 				break;
+
 		}
 
 		// biometric auth
@@ -198,43 +186,33 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 		Fragment fragmentById = fm.findFragmentById(R.id.fragment_container);
 
 		if(fragmentById instanceof SettingsFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleSettings));
 		}
 		else if(fragmentById instanceof MyRepositoriesFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleMyRepos));
 		}
 		else if(fragmentById instanceof StarredRepositoriesFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleStarredRepos));
 		}
 		else if(fragmentById instanceof OrganizationsFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleOrganizations));
 		}
 		else if(fragmentById instanceof ExploreFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleExplore));
 		}
 		else if(fragmentById instanceof NotificationsFragment) {
-
 			toolbarTitle.setText(R.string.pageTitleNotifications);
 		}
 		else if(fragmentById instanceof ProfileFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleProfile));
 		}
 		else if(fragmentById instanceof DraftsFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.titleDrafts));
 		}
 		else if(fragmentById instanceof AdministrationFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleAdministration));
 		}
 		else if(fragmentById instanceof UserAccountsFragment) {
-
 			toolbarTitle.setText(getResources().getString(R.string.pageTitleUserAccounts));
 		}
 
@@ -275,7 +253,7 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 
 				List<UserAccount> userAccountsList = new ArrayList<>();
 				UserAccountsApi userAccountsApi;
-				userAccountsApi = new UserAccountsApi(ctx);
+				userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
 
 				RecyclerView navRecyclerViewUserAccounts = hView.findViewById(R.id.userAccounts);
 				UserAccountsNavAdapter adapterUserAccounts;
@@ -294,12 +272,10 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 				userFullName.setTypeface(myTypeface);
 
 				if(!userEmailNav.equals("")) {
-
 					userEmail.setText(userEmailNav);
 				}
 
 				if(!userFullNameNav.equals("")) {
-
 					userFullName.setText(Html.fromHtml(userFullNameNav));
 				}
 
@@ -347,7 +323,8 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 			public void onDrawerSlide(@NonNull View drawerView, float slideOffset) {
 
 				navigationView.getMenu().findItem(R.id.nav_administration).setVisible(tinyDB.getBoolean("userIsAdmin"));
-				navigationView.getMenu().findItem(R.id.nav_notifications).setVisible(new Version(currentVersion).higherOrEqual("1.12.3"));
+				navigationView.getMenu().findItem(R.id.nav_notifications).setVisible(new Version(tinyDB.getString("giteaVersion")).higherOrEqual("1.12.3"));
+
 			}
 
 			@Override
@@ -361,6 +338,8 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 		toggle.syncState();
 		toolbar.setNavigationIcon(R.drawable.ic_menu);
 
+		String launchFragment = mainIntent.getStringExtra("launchFragment");
+
 		if(launchFragment != null) {
 
 			mainIntent.removeExtra("launchFragment");
@@ -368,13 +347,12 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 			switch(launchFragment) {
 
 				case "drafts":
-
 					toolbarTitle.setText(getResources().getString(R.string.titleDrafts));
 					getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new DraftsFragment()).commit();
 					navigationView.setCheckedItem(R.id.nav_comments_draft);
 					return;
-				case "notifications":
 
+				case "notifications":
 					toolbarTitle.setText(getResources().getString(R.string.pageTitleNotifications));
 					getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new NotificationsFragment()).commit();
 					navigationView.setCheckedItem(R.id.nav_notifications);
@@ -415,9 +393,7 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 		if(savedInstanceState == null) {
 
 			if(!new Version(tinyDB.getString("giteaVersion")).higherOrEqual("1.12.3")) {
-
 				if(tinyDB.getInt("homeScreenId") == 7) {
-
 					tinyDB.putInt("homeScreenId", 0);
 				}
 			}
@@ -658,29 +634,22 @@ public class MainActivity extends BaseActivity implements NavigationView.OnNavig
 
 	private void giteaVersion() {
 
-		final TinyDB tinyDb = TinyDB.getInstance(appCtx);
-
-		final String token = "token " + tinyDb.getString(tinyDb.getString("loginUid") + "-token");
-
-		Call<GiteaVersion> callVersion = RetrofitClient.getApiInterface(ctx).getGiteaVersionWithToken(token);
-
+		Call<GiteaVersion> callVersion = RetrofitClient.getApiInterface(ctx).getGiteaVersionWithToken(Authorization.get(ctx));
 		callVersion.enqueue(new Callback<GiteaVersion>() {
 
 			@Override
 			public void onResponse(@NonNull final Call<GiteaVersion> callVersion, @NonNull retrofit2.Response<GiteaVersion> responseVersion) {
 
-				if(responseVersion.code() == 200) {
+				if(responseVersion.code() == 200 && responseVersion.body() != null) {
+					String version = responseVersion.body().getVersion();
 
-					GiteaVersion version = responseVersion.body();
-					assert version != null;
-
-					tinyDb.putString("giteaVersion", version.getVersion());
+					tinyDB.putString("giteaVersion", version);
+					BaseApi.getInstance(ctx, UserAccountsApi.class).updateServerVersion(version, tinyDB.getInt("currentActiveAccountId"));
 				}
 			}
 
 			@Override
 			public void onFailure(@NonNull Call<GiteaVersion> callVersion, @NonNull Throwable t) {
-
 				Log.e("onFailure-version", t.toString());
 			}
 		});
diff --git a/app/src/main/java/org/mian/gitnex/activities/RepositorySettingsActivity.java b/app/src/main/java/org/mian/gitnex/activities/RepositorySettingsActivity.java
index 54e62e0d..1d5abfb6 100644
--- a/app/src/main/java/org/mian/gitnex/activities/RepositorySettingsActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/RepositorySettingsActivity.java
@@ -14,6 +14,7 @@ import org.gitnex.tea4j.models.RepositoryTransfer;
 import org.gitnex.tea4j.models.UserRepositories;
 import org.mian.gitnex.R;
 import org.mian.gitnex.clients.RetrofitClient;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.RepositoriesApi;
 import org.mian.gitnex.databinding.ActivityRepositorySettingsBinding;
 import org.mian.gitnex.databinding.CustomRepositoryDeleteDialogBinding;
@@ -139,7 +140,7 @@ public class RepositorySettingsActivity extends BaseActivity {
 					Toasty.success(ctx, getString(R.string.repoTransferSuccess));
 
 					finish();
-					RepositoriesApi.deleteRepository((int) tinyDB.getLong("repositoryId", 0));
+					BaseApi.getInstance(ctx, RepositoriesApi.class).deleteRepository((int) tinyDB.getLong("repositoryId", 0));
 					Intent intent = new Intent(RepositorySettingsActivity.this, MainActivity.class);
 					RepositorySettingsActivity.this.startActivity(intent);
 				}
@@ -220,7 +221,7 @@ public class RepositorySettingsActivity extends BaseActivity {
 					Toasty.success(ctx, getString(R.string.repoDeletionSuccess));
 
 					finish();
-					RepositoriesApi.deleteRepository((int) tinyDB.getLong("repositoryId", 0));
+					BaseApi.getInstance(ctx, RepositoriesApi.class).deleteRepository((int) tinyDB.getLong("repositoryId", 0));
 					Intent intent = new Intent(RepositorySettingsActivity.this, MainActivity.class);
 					RepositorySettingsActivity.this.startActivity(intent);
 				}
@@ -383,7 +384,7 @@ public class RepositorySettingsActivity extends BaseActivity {
 					if(!repositoryName.equals(repoName)) {
 
 						finish();
-						RepositoriesApi.updateRepositoryOwnerAndName(repositoryOwner, repoName, (int) tinyDB.getLong("repositoryId", 0));
+						BaseApi.getInstance(ctx, RepositoriesApi.class).updateRepositoryOwnerAndName(repositoryOwner, repoName, (int) tinyDB.getLong("repositoryId", 0));
 						Intent intent = new Intent(RepositorySettingsActivity.this, MainActivity.class);
 						RepositorySettingsActivity.this.startActivity(intent);
 					}
diff --git a/app/src/main/java/org/mian/gitnex/activities/SettingsNotificationsActivity.java b/app/src/main/java/org/mian/gitnex/activities/SettingsNotificationsActivity.java
index 1c378fd5..01d59a9c 100644
--- a/app/src/main/java/org/mian/gitnex/activities/SettingsNotificationsActivity.java
+++ b/app/src/main/java/org/mian/gitnex/activities/SettingsNotificationsActivity.java
@@ -43,7 +43,13 @@ public class SettingsNotificationsActivity extends BaseActivity {
 		viewBinding.enableNotificationsMode.setOnCheckedChangeListener((buttonView, isChecked) -> {
 
 			tinyDB.putBoolean("notificationsEnabled", isChecked);
-			if(!isChecked) Notifications.stopWorker(ctx);
+
+			if(isChecked) {
+				Notifications.startWorker(ctx);
+			} else {
+				Notifications.stopWorker(ctx);
+			}
+
 			Toasty.info(appCtx, getResources().getString(R.string.settingsSave));
 
 		});
diff --git a/app/src/main/java/org/mian/gitnex/adapters/DraftsAdapter.java b/app/src/main/java/org/mian/gitnex/adapters/DraftsAdapter.java
index f054c635..36374a24 100644
--- a/app/src/main/java/org/mian/gitnex/adapters/DraftsAdapter.java
+++ b/app/src/main/java/org/mian/gitnex/adapters/DraftsAdapter.java
@@ -17,6 +17,7 @@ import androidx.fragment.app.FragmentManager;
 import androidx.recyclerview.widget.RecyclerView;
 import org.mian.gitnex.R;
 import org.mian.gitnex.activities.IssueDetailActivity;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.DraftsApi;
 import org.mian.gitnex.database.models.DraftWithRepository;
 import org.mian.gitnex.fragments.BottomSheetReplyFragment;
@@ -56,8 +57,10 @@ public class DraftsAdapter extends RecyclerView.Adapter<DraftsAdapter.DraftsView
 
                 int getDraftId = draftWithRepository.getDraftId();
                 deleteDraft(getAdapterPosition());
-	            DraftsApi draftsApi = new DraftsApi(context);
+
+	            DraftsApi draftsApi = BaseApi.getInstance(context, DraftsApi.class);
 	            draftsApi.deleteSingleDraft(getDraftId);
+
             });
 
 	        itemView.setOnClickListener(itemEdit -> {
